var Lint = require("../lint");
describe("<label-undefined>", function () {
    var LabelUndefinedRule = Lint.Test.getRule("label-undefined");
    var fileName = "rules/label-undefined.test.ts";
    var failureString = LabelUndefinedRule.FAILURE_STRING;
    it("forbids the use of undefined labels", function () {
        var expectedFailures = [
            Lint.Test.createFailure(fileName, [6, 9], [6, 14], failureString + "lab1'"),
            Lint.Test.createFailure(fileName, [13, 9], [13, 17], failureString + "lab2'"),
            Lint.Test.createFailure(fileName, [27, 17], [27, 22], failureString + "lab3'"),
            Lint.Test.createFailure(fileName, [36, 9], [36, 17], failureString + "lab4'")
        ];
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, LabelUndefinedRule);
        Lint.Test.assertFailuresEqual(actualFailures, expectedFailures);
    });
});
