var Lint = require("../lint");
describe("<no-console>", function () {
    var NoConsoleRule = Lint.Test.getRule("no-console");
    var fileName = "rules/noconsole.test.ts";
    it("forbids access to specified console properties", function () {
        var dirFailure = Lint.Test.createFailuresOnFile(fileName, NoConsoleRule.FAILURE_STRING_PART + "console.dir")([3, 1], [3, 12]);
        var errorFailure = Lint.Test.createFailuresOnFile(fileName, NoConsoleRule.FAILURE_STRING_PART + "console.error")([7, 1], [7, 14]);
        var logFailure = Lint.Test.createFailuresOnFile(fileName, NoConsoleRule.FAILURE_STRING_PART + "console.log")([2, 1], [2, 12]);
        var warnFailure = Lint.Test.createFailuresOnFile(fileName, NoConsoleRule.FAILURE_STRING_PART + "console.warn")([6, 1], [6, 13]);
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, NoConsoleRule, [true, "dir", "error", "log", "warn"]);
        Lint.Test.assertContainsFailure(actualFailures, dirFailure);
        Lint.Test.assertContainsFailure(actualFailures, errorFailure);
        Lint.Test.assertContainsFailure(actualFailures, logFailure);
        Lint.Test.assertContainsFailure(actualFailures, warnFailure);
    });
});
