var Lint = require("../lint");
describe("<no-constructor-variable-declarations>", function () {
    var Rule = Lint.Test.getRule("no-constructor-vars");
    var fileName = "rules/noconstructorvars.test.ts";
    var failureString = Rule.FAILURE_STRING_PART;
    it("no constructor variable declarations", function () {
        var failureFoo = Lint.Test.createFailuresOnFile(fileName, "'foo'" + failureString);
        var failureBar = Lint.Test.createFailuresOnFile(fileName, "'bar'" + failureString);
        var expectedFailures = [
            failureFoo([3, 17], [3, 24]),
            failureFoo([9, 17], [9, 24]),
            failureBar([9, 38], [9, 44])
        ];
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, Rule);
        assert.lengthOf(actualFailures, 3);
        Lint.Test.assertFailuresEqual(actualFailures, expectedFailures);
    });
});
