var Lint = require("../lint");
describe("<no-duplicate-variable>", function () {
    var NoDuplicateVariableRule = Lint.Test.getRule("no-duplicate-variable");
    var fileName = "rules/no-duplicate-variable.test.ts";
    var failureString = NoDuplicateVariableRule.FAILURE_STRING + "duplicated'";
    it("ensures that variable declarations are unique within a scope", function () {
        var createFailure = Lint.Test.createFailuresOnFile(fileName, failureString);
        var expectedFailures = [
            createFailure([11, 13], [11, 23]),
            createFailure([22, 9], [22, 19]),
            createFailure([26, 5], [26, 15]),
            Lint.Test.createFailure(fileName, [141, 13], [141, 14], NoDuplicateVariableRule.FAILURE_STRING + "z'"),
            Lint.Test.createFailure(fileName, [153, 11], [153, 13], NoDuplicateVariableRule.FAILURE_STRING + "a2'"),
            Lint.Test.createFailure(fileName, [160, 10], [160, 11], NoDuplicateVariableRule.FAILURE_STRING + "x'"),
            Lint.Test.createFailure(fileName, [161, 17], [161, 18], NoDuplicateVariableRule.FAILURE_STRING + "y'")
        ];
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, NoDuplicateVariableRule);
        Lint.Test.assertFailuresEqual(actualFailures, expectedFailures);
    });
});
