var Lint = require("../lint");
describe("<no-string-literal>", function () {
    var NoStringLiteralRule = Lint.Test.getRule("no-string-literal");
    var fileName = "rules/sub.test.ts";
    it("forbids object access via string literals", function () {
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, NoStringLiteralRule);
        var expectedFailures = [
            Lint.Test.createFailure(fileName, [10, 20], [10, 25], NoStringLiteralRule.FAILURE_STRING),
            Lint.Test.createFailure(fileName, [11, 21], [11, 24], NoStringLiteralRule.FAILURE_STRING),
            Lint.Test.createFailure(fileName, [15, 5], [15, 23], NoStringLiteralRule.FAILURE_STRING),
            Lint.Test.createFailure(fileName, [16, 5], [16, 30], NoStringLiteralRule.FAILURE_STRING)
        ];
        expectedFailures.forEach(function (expectedFailure) {
            Lint.Test.assertContainsFailure(actualFailures, expectedFailure);
        });
    });
});
