var Lint = require("../lint");
describe("<no-switch-case-fall-through>", function () {
    var Rule = Lint.Test.getRule("no-switch-case-fall-through");
    var fileName = "rules/noswitchcasefallthrough.test.ts";
    it("Switch fall through", function () {
        var failureString = Rule.FAILURE_STRING_PART;
        var failureDefault = Lint.Test.createFailuresOnFile(fileName, failureString + "'default'");
        var failureCase = Lint.Test.createFailuresOnFile(fileName, failureString + "'case'");
        var expectedFailures = [
            failureCase([3, 15], [3, 16]),
            failureCase([6, 15], [6, 16]),
            failureDefault([8, 12], [8, 13]),
            failureCase([16, 15], [16, 16]),
            failureDefault([24, 12], [24, 13]),
            failureCase([35, 10], [35, 11]),
            failureDefault([32, 21], [32, 22])
        ];
        var actualFailures = Lint.Test.applyRuleOnFile(fileName, Rule);
        assert.lengthOf(actualFailures, 7);
        Lint.Test.assertFailuresEqual(actualFailures, expectedFailures);
    });
});
