var Lint = require("../lint");
describe("<use-strict>", function () {
    var UseStrictRule = Lint.Test.getRule("use-strict");
    var fileName = "rules/usestrict.test.ts";
    var actualFailures;
    before(function () {
        var options = [true, "check-function", "check-module"];
        actualFailures = Lint.Test.applyRuleOnFile(fileName, UseStrictRule, options);
        assert.lengthOf(actualFailures, 3);
    });
    it("enforces checks for 'use strict' in functions", function () {
        var expectedFailures = Lint.Test.createFailure(fileName, [14, 1], [14, 9], UseStrictRule.FAILURE_STRING);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailures);
    });
    it("enforces checks for 'use strict' in modules", function () {
        var expectedFailures = Lint.Test.createFailure(fileName, [24, 1], [24, 7], UseStrictRule.FAILURE_STRING);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailures);
    });
    it("enforces checks for 'use strict' in module declaration with more than one identifier", function () {
        var expectedFailures = Lint.Test.createFailure(fileName, [29, 1], [29, 7], UseStrictRule.FAILURE_STRING);
        Lint.Test.assertContainsFailure(actualFailures, expectedFailures);
    });
});
